; ------------------------
; Iniciamos como siempre |
; ------------------------

	.386
	.model flat,stdcall
	option casemap:none

; ----------------------------------------
; Aadimos los include que necesitaremos |
; ----------------------------------------
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comdlg32.inc
;include d:\masm32\include\vmm.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comdlg32.lib


	; ==========
	; = MACROS =
	; ==========

	NTSIGNATURE MACRO pF
; Devuelve en eax el contenido del campo signatura.
; Pasar como parmetro el puntero a la vista proyectada.
	mov eax,pF
	movzx ebx,word ptr [eax+03Ch] ; eax = offset de la signatura
	add eax,ebx
	movzx eax,word ptr [eax]
	ENDM

	PEFHDROFFSET MACRO pF
; Devuelve en eax un puntero al encabezado PE
; Pasar como parmetro el puntero a la vista proyectada.
	mov eax, pF
	add eax, dword ptr [eax+03Ch] ; eax = offset de la signatura
	add eax, 4                    ; eax = offset del inicio del encabezado PE
	ENDM

	OPTHDROFFSET MACRO pF
; Devuelve en eax un puntero al encabezado opcional PE
; Pasar como parmetro el puntero a la vista proyectada.
        PEFHDROFFSET pF ; devuelve eax = offset del inicio del encabezado PE
	add eax, SIZEOF IMAGE_FILE_HEADER
	ENDM

	SECHDROFFSET MACRO pF
; Devuelve en eax un puntero a la tabla de secciones secciones
; Pasar como parmetro el puntero a la vista proyectada.
        OPTHDROFFSET pF ; devuelve eax = offset del inicio del encabezado op.
	add eax, SIZEOF IMAGE_OPTIONAL_HEADER 
	ENDM

; ==========================================================================

; -----------------------------
; Definicion de los elementos |
; Botones, editboxs, etc      |
; -----------------------------
	.const
IDD_DIALOG                               equ       100
IDD_EDDIALOG                             equ       101
IDC_AYUDA				 equ	  3002
IDC_ORIGINAL                             equ      3004
IDC_KRAKEADO                             equ      3005
IDC_BORIGINAL                            equ      3006
IDC_BKRAKEADO                            equ      3007
IDC_ACERCA                               equ      3003
IDC_KOMPARA                              equ      3008
IDC_EXIT                                 equ      3009
IDC_BKRAK                                equ      3011
IDC_KRAK                                 equ      3010
IDC_NOMBREPROG                           equ      3012
IDC_ACERCATXT                            equ      3013
IDC_BTXT                                 equ      3014
IDC_SAVEA				 equ      3016
IDC_STATIC                               equ        -1

; --------------------------------------------
; Definimos los datos y cadenas de texto que |
; necesitamos                                |
; --------------------------------------------
	.data
txt1        db "                 haZedor v1.63", 10, 13, 10, 13
            db "    By  J o T a K e  and  n u M I T_o r", 10, 13, 10, 13
            db "(C) Askatasuna Crackers Society 2000", 0
txt2        db "JoTaKe",0
filtro      db "Executable files (*.exe, *.dll)",0,"*.exe; *.dll", 0
            db "All files (*.*)",0,"*.*",0,0
filtrotxt   db "Text files (*.txt)",0,"*.txt",0
            db "All files (*.*)",0,"*.*",0,0
txtnoor     db "Fail to open original file",0
txtnokr     db "Fail to open cracked file",0
txtnomemor  db "Has failed the memory for original file",0
txtnomemkr  db "Has failed the memory for cracked file",0
txtnomemtx  db "Has failed the memory for the crack",0
txtnomta    db "The files have diferent size : (",0
txtesigual  db "The files are identical",0
txtnoabkrak db "Fail to open the krack",0
txtnotxt    db "Fail to open the text file for About message",0
txtgrtxt    db "The About text is very long",0
ndebytes    db "    diferent bytes",0
k32         db "Kernel32.dll",0
InMem	    db "The info is not saved in disk (is in memory)", 0
msg0 	    db "Does exist a file with this name", 10, 13
	    db "Do you want over write it?", 0
msg1	    db "Do you want to save this info in a text file?", 0
msg2	    db "Text is not on disk (it is in memory)", 0
msg3	    db "The crack has been created!", 0
HelpFile    db "haZedor.hlp", 0
cont	    db "haZedor: what is?", 0
capt	    db "haZedor"
szZero	    db 0

; ----------------------------
; Un par de datos necesarios |
; ----------------------------
dirnomb     dd 0108Ah
memdirs     dd 0


; ----------------------------------------------------------------
; Datos no inicializados, estan aqui para que no ocupen sitio en |
; el ejecutable.                                                 |
; ----------------------------------------------------------------
	.data?
; ------------------------------------------
; Necesitaremos la estructura OPENFILENAME |
; ------------------------------------------
ofn             OPENFILENAME <>

; ------------------------------------
; Bufers para los nombres de artxibo |
; ------------------------------------
oriartx     db MAX_PATH dup (?)
krakartx    db MAX_PATH dup (?)
nombrekr    db MAX_PATH dup (?)
txtacerca   db MAX_PATH dup (?)
dir         db MAX_PATH dup (?)
nombrepr    db 25 dup (?)

; -----------------------------------
; Algunos Handles y otras variables |
; -----------------------------------
artx        dd ?
fhandleo    dd ?
fhandlek    dd ?
fhandlekrak dd ?
fhandletxt  dd ?
hIcon       dd ?
hExe        dd ?
hInstance   dd ?
fsizeor     dd ?
fsizekr     dd ?
fsizetxt    dd ?
bleidosor   dd ?
bleidoskr   dd ?
bleidotx    dd ?
bleidotxt   dd ?
byteescrito dd ?    
memor       dd ?
memkr       dd ?
memtx       dd ?
memyxt      dd ?
guarda      dd ?
cuant       dd ?
tamart      dd ?
tamaltxt    dd ?
hDlg2       dd ?
TextoAcerca dd ?
DataOffset  dd ?
viradr      dd ?

; --------------------------
; La funcion de la ventana |
; --------------------------
DlgFunc PROTO :DWORD,:DWORD,:DWORD,:DWORD
EdDialog PROTO :DWORD,:DWORD,:DWORD,:DWORD

; -------------------
; Empieza el codigo |
; -------------------
	.code
start:
; -------------------------------------------
; Obtener el handle para nuestro programa   |
; -------------------------------------------
	invoke GetModuleHandle,NULL
	mov hInstance,eax
        invoke DialogBoxParam,hInstance,IDD_DIALOG,NULL,addr DlgFunc,NULL
 	invoke ExitProcess,NULL

; --------------------------
; La funcion de la ventana |
; --------------------------

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

DlgFunc proc hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

.if uMsg==WM_INITDIALOG
	invoke GetCurrentDirectory, 256, addr dir

; -------------------------
; Cargar y poner el Icono |
; -------------------------
	invoke LoadIcon,hInstance,500
	mov hIcon,eax
	invoke SendMessage,hDlg,WM_SETICON,ICON_BIG,hIcon

; -------------------------------------------------------------------------
; Guardar Handle de la ventana para un call fuera de ella que lo necesita |
; -------------------------------------------------------------------------
	push hDlg
	pop hDlg2

; -------------------------
; Estructura OPENFILENAME |
; -------------------------
	mov ofn.lStructSize,SIZEOF ofn 
	push hDlg
	pop  ofn.hwndOwner 
	push hInstance 
	pop  ofn.hInstance 
	mov  ofn.lpstrFilter, OFFSET filtro 
	mov  ofn.lpstrFile, offset oriartx
	mov  ofn.nMaxFile, MAX_PATH
	mov  ofn.Flags, OFN_FILEMUSTEXIST or \ 
        	OFN_PATHMUSTEXIST or OFN_LONGNAMES or\ 
        	OFN_EXPLORER or OFN_HIDEREADONLY

; ---------------------
; Si pulsamos X adios |
; ---------------------
.elseif uMsg==WM_CLOSE
	invoke EndDialog,hDlg,NULL	

.elseif uMsg==WM_COMMAND
	mov eax,wParam
	mov edx,eax 
	shr edx,16 
	.if dx==BN_CLICKED 
; ------------------------------------
; Las pulsaciones sobre los botones  |
; de buscar, con el resultado        |
; rellenamos el path de cada artxibo |
; ------------------------------------
          .if ax==IDC_BORIGINAL
		mov  ofn.lpstrFilter, OFFSET filtro 
		mov  ofn.lpstrFile, offset oriartx
		invoke GetOpenFileNameA,ADDR ofn
	 	invoke  SetDlgItemText,hDlg,IDC_ORIGINAL,ADDR oriartx


           .elseif ax==IDC_BKRAKEADO
		mov  ofn.lpstrFilter, OFFSET filtro 
		mov  ofn.lpstrFile, offset krakartx
		invoke GetOpenFileNameA,ADDR ofn
		invoke SetDlgItemText,hDlg,IDC_KRAKEADO,ADDR krakartx
		mov  ofn.lpstrFile, offset oriartx

; -------------------------------------------------
; Para este necesitamos unos ofn.Flags diferentes |
; que debemos restaurar despues de la llamada     |
; a GetOpenFileNameA para no tener que hacer lo   |
; mismo en el resto  de los botones               |
; -------------------------------------------------
            .elseif ax==IDC_BKRAK
		mov  ofn.lpstrFilter, OFFSET filtro 
		mov  ofn.lpstrFile, offset nombrekr
		mov  ofn.Flags, OFN_PATHMUSTEXIST or OFN_LONGNAMES or\ 
		        OFN_EXPLORER or OFN_HIDEREADONLY
		invoke GetOpenFileNameA,ADDR ofn
		invoke SetDlgItemText,hDlg,IDC_KRAK,ADDR nombrekr
		mov  ofn.Flags, OFN_FILEMUSTEXIST or \ 
		        OFN_PATHMUSTEXIST or OFN_LONGNAMES or\ 
		        OFN_EXPLORER or OFN_HIDEREADONLY
		mov  ofn.lpstrFile, offset oriartx

            .elseif ax==IDC_BTXT
; ---------------------------------------------------------
; Abrir archivo de texto con contenido para dilogo acerca
; ---------------------------------------------------------
		mov  ofn.lpstrFilter, OFFSET filtrotxt 
		mov  ofn.lpstrFile, offset txtacerca
		invoke GetOpenFileNameA,ADDR ofn
		mov  ofn.lpstrFilter, OFFSET filtro 
		mov  ofn.lpstrFile, offset oriartx
		.if eax==0
			inc al
			ret
		.endif		
set_txtacerca:	invoke SetDlgItemText,hDlg,IDC_ACERCATXT,ADDR txtacerca

	     .elseif ax==IDC_SAVEA
			invoke DialogBoxParam, hInstance, IDD_EDDIALOG, hDlg, addr EdDialog, 0
			jmp set_txtacerca

             .elseif ax==IDC_ACERCA
; --------------
; Botn Acerca
; --------------
		invoke MessageBox,hDlg,ADDR txt1,ADDR txt2,MB_OK

	     .elseif ax==IDC_AYUDA
		; --------------------
		; Display the help
		; Desplegar la ayuda
		; --------------------
	               push offset cont
	               push HELP_KEY
	               push offset HelpFile
		       push hDlg
		       call WinHelp

             .elseif ax==IDC_EXIT
		invoke SendMessage,hDlg,WM_CLOSE,0,0

             .elseif ax==IDC_KOMPARA
; -------------------------------------------------
; Empezemos a abrir los artxibos para compararlos |
; -------------------------------------------------
		pushad
		invoke GetDlgItemText, hDlg, IDC_ORIGINAL, ADDR oriartx, MAX_PATH
		invoke GetDlgItemText, hDlg, IDC_KRAKEADO, ADDR krakartx, MAX_PATH
		xor ebx, ebx
		invoke CreateFile,ADDR oriartx,GENERIC_READ, ebx, ebx,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL, ebx
		.if eax==-1
			invoke MessageBox,hDlg,ADDR txtnoor,ADDR txt2,MB_ICONEXCLAMATION
		   	popad
		    	ret
		.endif
		mov fhandleo,eax

		invoke CreateFile,ADDR krakartx,GENERIC_READ, ebx, ebx,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL, ebx
		.if eax==-1
			invoke MessageBox,hDlg,ADDR txtnokr,ADDR txt2,MB_ICONEXCLAMATION
			jmp close_handle
		.endif
		mov fhandlek,eax
; ---------------------------------------------------
; Obtenemos el tamao de los artxibos para comparar |
; ---------------------------------------------------
		invoke GetFileSize, fhandleo, NULL
		mov fsizeor,eax
		mov ebx,eax
		invoke GetFileSize, fhandlek, NULL
		.if ebx!=eax
			invoke MessageBox,hDlg,ADDR txtnomta,ADDR txt2,MB_ICONEXCLAMATION
        	        jmp close_handles
		.endif
		mov fsizekr,eax
; ---------------------------------------------------------------
; Tienen el mismo tamao asi que seguimos reservandoles memoria |
; ---------------------------------------------------------------
mismotamaino:   xor ebx, ebx
		invoke GlobalAlloc, ebx, fsizeor
		.if eax==0
		    	invoke MessageBox,hDlg,ADDR txtnomemor,ADDR txt2,MB_ICONEXCLAMATION
		    	jmp close_handles
		.endif
		mov memor,eax

		invoke GlobalAlloc, ebx, fsizekr
		.if eax==0
		    	invoke MessageBox,hDlg,ADDR txtnomemkr,ADDR txt2,MB_ICONEXCLAMATION
		    	jmp free_mem2
		.endif
		mov memkr,eax

; ------------------------------------------------
; Una vez reservada la memoria los leemos a ella |
; ------------------------------------------------
		invoke ReadFile,fhandleo,memor,fsizeor,ADDR bleidosor, ebx
		invoke ReadFile,fhandlek,memkr,fsizekr,ADDR bleidoskr, ebx

; -----------------------------------------------------------
; Empezamos la comparacin de bytes entre los dos artxibos  |
; guarda=0 asi que no guardamos los datos (bytes diferentes |
; -----------------------------------------------------------
		push ebx
		pop guarda
		call comparador

; -------------------------------------------------------------------------
; Terminamos la comparacion, si hay 0 bytes diferentes nos vamos          |
; Sino seguimos adelante traduciendo el n de bytes a caracter imprimible |
; -------------------------------------------------------------------------
		.if ebx==0
	    		invoke MessageBox,hDlg,ADDR txtesigual,ADDR txt2,MB_ICONEXCLAMATION
	    		jmp free_mem1
		.endif

		mov ecx,0Ah
		mov eax,ebx
		push eax
		pop cuant
		push eax
		xor edx,edx
		mov edi,offset ndebytes

divide:         div ecx
		add edx,30h
		mov byte ptr [edi],dl
		test eax,eax
		jz numero
		inc edi
		xor edx,edx
		jmp divide

; --------------------------------------------------------------------
; Una vez conseguido el n lo mandamos en una MessageBox y damos la  |
; oportunidad de seguir o cancelar, por si son demasiados bytes y no |
; se quiere seguir.				                     |
; --------------------------------------------------------------------
numero:         invoke MessageBox,hDlg,ADDR ndebytes,ADDR txt2,MB_OKCANCEL or MB_ICONQUESTION
		.if eax==IDCANCEL
			pop eax
			jmp free_mem1
		.endif

; --------------------------------------------------------------------
; Si seguimos calculamos el espacio que necesitaremos para los datos |
; y les reservamos memoria. Ponemos guarda=1 y volvemos a comparar,  |
; esta vez guardar los datos de la comparacion.                    |
; --------------------------------------------------------------------
keremas:        pop ebx
		imul eax, ebx, 06h
		push eax

		invoke GlobalAlloc, NULL, eax
		mov memdirs, eax
		push 01h
		pop guarda
		call comparador
		invoke GlobalFree,memor
		invoke GlobalFree,memkr
		invoke CloseHandle,fhandleo
		invoke CloseHandle,fhandlek

; -------------------------------------------------------
; Creamos el archivo krak y reservamos memoria para el. |
; -------------------------------------------------------
		invoke GetDlgItemText, hDlg, IDC_KRAK, ADDR nombrekr, MAX_PATH
		xor eax, eax
		invoke CreateFile,ADDR nombrekr,GENERIC_READ + GENERIC_WRITE, eax, eax,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL, eax
		.if eax==-1
		        invoke MessageBox,hDlg,ADDR txtnoabkrak,ADDR txt2,MB_ICONEXCLAMATION
			invoke GlobalFree, memdirs
		        pop eax
		        popad
		        ret
		.endif
		mov fhandlekrak,eax

; -------------------------------------------------------------------------
; Operaciones para el aligment, asi sabemos cuntos bloques de 512 bytes  |
; necesitamos aadir antes de reservar memoria para el krak :)            |
; -------------------------------------------------------------------------
		pop eax
		call alineam
		mov tamart, eax
		.if TextoAcerca==0
                 	invoke GetDlgItemText, hDlg2, IDC_ACERCATXT, ADDR txtacerca, MAX_PATH
                        xor eax, eax
                        invoke CreateFile,ADDR txtacerca,GENERIC_READ, eax, eax,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL, eax
                        mov fhandletxt,eax
                        .if eax==-1
                            invoke MessageBox,hDlg2,ADDR txtnotxt,ADDR txt2,MB_OK
			    jmp close_hand
                        .endif
                        invoke GetFileSize,fhandletxt,NULL
                        mov fsizetxt,eax
		.else
			mov fhandletxt, 0
		.endif
; -------------------------------------------------------------------------
; Buscamos el recurso, lo cargamos y lo situamos en memoria para copiarlo |
; byte a byte a la memoria reservada para el artxibo krak (El recurso es  |
; el exe del patxer genrico).		                                  |
; -------------------------------------------------------------------------
		invoke FindResource,hInstance,505,600
		mov hExe,eax
		invoke LoadResource,hInstance,eax
		mov  artx,eax
		invoke LockResource,eax
		mov  esi,eax
		invoke SizeofResource, hInstance, hExe
		mov  DataOffset, eax
; ---------------------------------------
; Calcular tamao de memoria a localizar
; ---------------------------------------
		mov  eax, fsizetxt
		call alineam
		mov  tamaltxt, eax
		add  eax, DataOffset
		add  eax, tamart
; ---------------------------------
; Reservamos memoria para el crack
; ---------------------------------
		invoke GlobalAlloc, 0, eax
		.if eax==0
		    invoke MessageBox,hDlg,ADDR txtnomemtx,ADDR txt2,MB_ICONEXCLAMATION
		    jmp close_hand
		.endif
		mov memtx, eax
; -------------------------------------------------------------------------
; Copiamos byte a byte a la memoria reservada el artxibo krak             |
; -------------------------------------------------------------------------
		mov  edi, eax
		mov  ecx, DataOffset
		push eax
		dec  ecx
		push ecx
		inc  ecx
		push eax
		rep  movsb
; ---------------------------------------------------------------
; Obtenemos la direccin virtual dnde insertar los datos nuevos
; ---------------------------------------------------------------
		call Offset2VA
		inc  eax
		mov  viradr, eax
; -----------------------------------------------------
; Ahora cogemos el nombre de programa y lo insertamos |
; -----------------------------------------------------
yaestacop:      invoke GetDlgItemText,hDlg,IDC_NOMBREPROG,ADDR nombrepr, 25
		pop edi
		add edi, dirnomb
		mov esi, offset nombrepr

siguepr:        lodsb
		test al,al
		jz nombrelisto
		stosb
		inc edi
		jmp siguepr

; -------------------------------------------------------------------
; Ahora copiamos los datos del krack, direcciones y bytes a cambiar. |
; -------------------------------------------------------------------
nombrelisto:    mov edi, memtx
		add edi, DataOffset
		mov esi, memdirs
		mov ecx, cuant
siguokrak:      lodsd
		stosd
		lodsw
		stosw
		loop siguokrak

; --------------------------------------------------------------------
; Una vez hecho todo abrimos el txt para el texto de Acerca del krak |
; lo copiamos y ya esta todo.		                             |
; --------------------------------------------------------------------
tamb:           invoke GlobalAlloc,NULL,fsizetxt
		.if eax==0
		    invoke MessageBox,hDlg,ADDR txtnomemtx,ADDR txt2,MB_ICONEXCLAMATION
 		    jmp free_mem
		.endif

		mov memyxt,eax
		mov ecx, fsizetxt
		.if TextoAcerca!=0
			mov esi, TextoAcerca
			mov edi, eax
			rep movsb
			invoke GlobalFree, TextoAcerca
			mov TextoAcerca, 0
			invoke SetDlgItemText, hDlg, IDC_ACERCATXT, ADDR szZero
		.else
			invoke ReadFile, fhandletxt, eax, ecx, ADDR bleidotxt, NULL
		.endif
		mov esi, memyxt
		mov edi, memtx
		add edi, DataOffset
		add edi, tamart
		mov ecx, fsizetxt
		rep movsb
		xor al, al
		stosb
fintxt:		call arreglah
		mov eax, tamart
		add eax, DataOffset
		add eax, tamaltxt
		invoke WriteFile,fhandlekrak,memtx,eax,ADDR byteescrito,NULL
		invoke MessageBox, hDlg, addr msg3, addr txt2, MB_ICONINFORMATION
; --------------------------------------------------------------------------
; Aqui ya cerramos todo, tenemos abierto todavia el txt y el krak, el krak |
; todavia sin escribir al artxibo.		                           |
; --------------------------------------------------------------------------		
	        invoke GlobalFree, memyxt
free_mem:	invoke GlobalFree, memtx
		invoke CloseHandle, fhandletxt
close_hand:	invoke CloseHandle, fhandlekrak
		invoke GlobalFree, memdirs
		popad
		mov eax, 1
                ret

free_mem1:	invoke GlobalFree, memkr
free_mem2:	invoke GlobalFree, memor
close_handles:	invoke CloseHandle, fhandlek
close_handle:	invoke CloseHandle, fhandleo
		popad
	   .endif
       .endif
.else
mov	eax, 0
ret

.endif
mov	eax, 1
ret

DlgFunc endp


; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

comparador:             xor ebx,ebx
                        xor ecx,ecx
                        push 00
                        mov edi,memor
                        mov esi,memkr

masbytes:               mov dl,byte ptr [esi]
                        cmp byte ptr [edi],dl
                        jz igual
                        imul eax,ebx,06h
                        inc ebx
                        mov ecx, memdirs
                        pop edx
                        push edx

                        push eax
                        mov eax, guarda
                        .if eax==1
                        	pop eax
                        	mov dword ptr [ecx+eax],edx
                        	mov dl,byte ptr [edi]
                        	mov byte ptr [ecx+eax+4],dl
                        	mov dl,byte ptr [esi]
                        	mov byte ptr [ecx+eax+5],dl
                        .elseif
                        	pop eax
                        .endif

igual:                  inc edi
                        inc esi
                        pop ecx
                        inc ecx
                        mov edx,fsizeor
                        cmp ecx,edx
                        jz yaesta
                        push ecx
                        jmp masbytes
yaesta:                 ret

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

; --------------------------------------------------------------
; Arreglamos el alineamiento y tamao ejecutable de la seccion |
; --------------------------------------------------------------
arreglah:		pusha
	                mov edi, memtx

                        mov eax, tamart	; tamao de los datos nuevos
			push eax
; ---------------
; Tamao virtual
; ---------------
                        add eax, 200h
                        add eax, fsizetxt
			mov ecx, edi
			add ecx, [ecx+03Ch]
			add [ecx+4+14h+0E0h+120+8], eax

; ------------
; Tamao real
; ------------
			pop eax
			push eax
                        add eax, tamaltxt
			add [ecx+4+14h+0E0h+120+10h], eax

; ------------------------------------------------------
; Ahora arreglamos las dir de datos y txt para el krak |
; ------------------------------------------------------
	; Los datos estn al inicio de la seccin de datos,
	; as que obtenemos la direccin de esta seccin.
                        mov  edi, memtx
			push 2
			push edi			
			call GetOffsetOfSection
                        add  edi, eax
                        mov  ecx, viradr
                        pop  eax
                        add  eax, ecx
                        mov  dword ptr [edi], eax
                        mov  dword ptr [edi+4], ecx

; ---------------------------------------------
; Por ltimo, arreglamos el tamao de la imagen
; ---------------------------------------------
			mov ecx, 1000h		; Section Alignment		
                        mov edi, memtx
			mov edx, edi
			add edx, [edx+03Ch]
			mov eax, [edx+4+14h+0E0h+50h+8]		; V. size
			add eax, [edx+4+14h+0E0h+50h+10h]	; V. Address
			xor edx, edx
			div ecx
			or  edx, edx
			je  @00
			inc eax
@00:			xor edx, edx
			mul ecx
			add edi, dword ptr [edi+3Ch]
			mov [edi+4+14h+38h], eax
			popa						
                        ret

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
; --------------------------------------
; Debe venir el tamao en bytes en eax |
; --------------------------------------
alineam:                mov ecx, 200h
			xor edx, edx
alig:                   cmp eax, ecx
                        jl yaalig

                        inc edx
                        sub eax, ecx
                        jmp alig

yaalig:                 inc edx
                        push edx
                        pop eax
			xor edx, edx
                        mul ecx
                        ret

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

EdDialog proc uses esi edi \ 
	 hdlg:DWORD, msg:DWORD, wParam:DWORD, lParam:DWORD
local x:DWORD
	mov eax, msg
	.if eax==WM_INITDIALOG
	    .if TextoAcerca!=0
		invoke GlobalFree, TextoAcerca
 		mov TextoAcerca, 0
	    .endif

	.elseif eax==WM_COMMAND
		mov eax, wParam
		 .if ax==IDOK
			invoke GetDlgItem, hdlg, 3015
			push eax
			invoke GetWindowTextLength, eax
			mov fsizetxt, eax
			inc eax
			push eax
			invoke GlobalAlloc, 0, eax
			mov esi, eax
			pop edx
			pop ecx
			invoke GetWindowText, ecx, eax, edx
			invoke MessageBox, hdlg, addr msg1, addr capt, MB_ICONQUESTION or MB_YESNO
		        .if eax==IDYES
				push ofn.lpstrFilter
				push ofn.lpstrFile
	                	mov  ofn.lpstrFilter, OFFSET filtrotxt 
               			mov  ofn.lpstrFile, offset txtacerca
				invoke GetSaveFileName, addr ofn
				pop  ofn.lpstrFile
				pop  ofn.lpstrFilter
				.if eax!=0
					invoke CreateFile, addr txtacerca, GENERIC_WRITE, 0, 0, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, 0
					 .if eax==-1
						invoke MessageBox, hdlg, addr msg0, addr capt, MB_YESNO	or MB_ICONEXCLAMATION
						 .if eax==IDYES
							invoke CreateFile, addr txtacerca, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
						 .else
							invoke GlobalFree, esi
							mov eax, 1
							ret
						 .endif
					 .endif
					lea ecx, x
					push eax
					invoke WriteFile, eax, esi, fsizetxt, ecx, 0
					call   CloseHandle
					invoke GlobalFree, esi
					mov  esi, 0
				.else
					invoke lstrcpy, addr txtacerca, addr msg2
				.endif
			.else
				invoke lstrcpy, addr txtacerca, addr msg2
			.endif
			mov TextoAcerca, esi
			jmp _close

		 .elseif eax==IDCANCEL
			jmp _close

		 .endif

	.elseif ax==WM_CLOSE
_close:		invoke EndDialog, hdlg, 0

	.else
		xor eax, eax
		ret
 	.endif
	mov eax, 1
	ret
EdDialog endp

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

; ======================================================================
;                       Offset2VA procedure
; ======================================================================

Offset2VA:    push ebp
              mov ebp, esp

              push esi
              push edi
; ---------------------------
; Get the number of sections
; ---------------------------
              PEFHDROFFSET dword ptr [ebp+08h]  ; pFile
              movzx ecx, word ptr [eax+2]
; --------------------------------
; Get a pointer to sections header
; --------------------------------
              SECHDROFFSET [ebp+08h]
              mov esi, eax
; ------------------
; Get the image base
; ------------------
              OPTHDROFFSET dword ptr [ebp+08]
              mov edi, dword ptr [eax+1Ch]

n00:          mov eax, [esi+14h] ; sect_rawoffset
              cmp [ebp+0Ch], eax
              jl n01

              add eax, [esi+10h] ; sect_rawoffset + section_size
              cmp [ebp+0Ch], eax
              jge n01
              
; ---------------------------------
; Convert offset to virtual address
; ---------------------------------
              mov eax, dword ptr [ebp+0Ch] ; offset to convert
              sub eax, dword ptr [esi+14h] ; offset from raw of section
              add eax, dword ptr [esi+0Ch] ; offset plus rva offset
              add eax, edi
              jmp n03

n01:          add esi, 028h
              loop n00

n02:          xor eax, eax
n03:          pop edi
              pop esi
              leave
              ret 8

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

GetOffsetOfSection:
		cmp	dword ptr [esp+8], 10h
		jge	ret_f
; -----------------------------------------------
; get a pointer to the section header
; obtener un puntero al encabezado de la seccin
; -----------------------------------------------
		mov	eax, [esp+4]
		add	eax, [eax+3Ch]
; -----------------------------
; get the number of sections
; obtenerelnmero de secciones
; ----------------------------
		push	eax
		movzx	ecx, word ptr [eax+6]
		pop	eax
; --------------------------
; Existe la seccin
; Does exist the section 
; ---------------------------
		cmp	ecx, [esp+8]
		jl	ret_f

		add	eax, 4+14h+0E0h
		push	eax
		xor	edx, edx
		mov	eax, 28h
		mov     ecx, [esp+0Ch]
		mul	ecx
		pop	ecx
		add	eax, ecx
		mov	eax, [eax+14h]
		ret	8

ret_f:		xor	eax, eax
		ret	8

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

end start

; ------------------------------------------------------------------------
; Las direcciones donde se pone el nombre del programa se busca con un 
; editor hexadecimal.                                                    
; ------------------------------------------------------------------------
; ----------------------------------------------
; Cualquier duda Askatasuna_Crackers@iname.com | 
; ----------------------------------------------
; --------------------------------------------------
; AUTORES:            JoTaKe & nuMIT_or            |
;            (C) Askatasuna Crackers Society 2000  |
; --------------------------------------------------
